#include <stdio.h>
#include <memory.h>
#include <string.h>
#include <stdlib.h>

struct ChunkIFF
{
	unsigned int type, size;
};

struct vector3f
{
	float x,y,z; 
};

struct vector2f
{
	float tx,ty; 
};

struct face
{
	unsigned short f0,f1,f2; 
};

struct msh_bbox {
	struct vector3f		min;
	struct vector3f		max;
};

char mbuf[_MAX_PATH];

int main(int argc, char* argv[])
{
	ChunkIFF ih;
  unsigned long i, fullsize=0, initsize=0;
	char fileName[256];
  FILE *inputFile;

 	printf("X-Ray spawn (2xxx+) parser-converter [201205xx]\n");
	if (argc < 2) 
  {
		printf("usage: parse_spw < game.spawn >\n");
		return 1;
	}

	strcpy((char*)fileName,argv[1]);

  inputFile = fopen(fileName,"rb");
	if(!inputFile)
  {
 	printf("ERR: cannot open.\n");
  return 1;
  }

	fseek(inputFile,0,SEEK_END);
  fullsize = ftell(inputFile);
	fseek(inputFile,0,SEEK_SET);
	while(initsize < fullsize)
	{
  fread( &ih, sizeof(ChunkIFF), 1, inputFile );
  printf("Type 0x%04X, size 0x%04X - ",ih.type,ih.size);
  initsize+=8;

	char *tmpdata = new char[ih.size];
	fread(tmpdata,ih.size,1,inputFile);
	printf("%s, ",&tmpdata[2]); // skip word 
	i = strlen(&tmpdata[2]);
	printf("%s\n",&tmpdata[2+i+1]);
	//sprintf(mbuf,"%s\n",tmpdata);

	delete [] tmpdata;
  initsize+=ih.size;
  }
	printf("Full size is 0x%08X (%u)\n",fullsize,fullsize);

  fclose(inputFile);
	return 0;
	}