#include <stdio.h>
#include <ddraw.h>
#include <windows.h>

char lbuf[_MAX_PATH]; // printf messages

int main(void)
{
	
	LPDIRECTDRAW7 pDD;

 HFONT hFnt;
 HDC m_DContext = GetWindowDC(GetDesktopWindow());
// SetBkMode(m_DContext,TRANSPARENT);
 SetBkColor(m_DContext,0);
	SetTextColor(m_DContext,0x00FF00);

	hFnt = CreateFont(	-19,	// Height Of Font
	0,	// Width Of Font
	0,	// Angle Of Escapement
	0,	// Orientation Angle
	FW_NORMAL,	// Font Weight
	FALSE,	// Italic
	FALSE,	// Underline
	FALSE,	// Strikeout
	ANSI_CHARSET,	// Character Set Identifier
	OUT_TT_PRECIS,	// Output Precision
	CLIP_DEFAULT_PRECIS,	// Clipping Precision
	ANTIALIASED_QUALITY,	// Output Quality
	FF_DONTCARE|DEFAULT_PITCH,	// Family And Pitch
	"Lucida Console");	// Font Name
	SelectObject(m_DContext,hFnt);
	
	if (DirectDrawCreateEx(NULL, (void **)&pDD, IID_IDirectDraw7, NULL)!=DD_OK)
		return(0);
	
	HRESULT hr;
	DDSCAPS2 ddsGAVMCaps;
	DWORD dwVidMemTotal0, dwVidMemFree0,
	 dwVidMemTotal1, dwVidMemFree1,
	 dwVidMemTotal2,  dwVidMemFree2,
	 dwVidMemTotal3, dwVidMemFree3;

	ZeroMemory(&ddsGAVMCaps, sizeof(DDSCAPS2));

	while (1) {

	ddsGAVMCaps.dwCaps = DDSCAPS_VIDEOMEMORY;
	hr = pDD->GetAvailableVidMem(&ddsGAVMCaps, &dwVidMemTotal0, &dwVidMemFree0);
  sprintf(lbuf,"TOTAL:  %10u  FREE:  %10u - VIDEO",dwVidMemTotal0, dwVidMemFree0);
	TextOut(m_DContext,10,110,lbuf,strlen(lbuf));

	ddsGAVMCaps.dwCaps = DDSCAPS_VIDEOMEMORY | DDSCAPS_LOCALVIDMEM;
	hr = pDD->GetAvailableVidMem(&ddsGAVMCaps, &dwVidMemTotal1, &dwVidMemFree1);
  sprintf(lbuf,"TOTAL:  %10u  FREE:  %10u - VIDEO[LOCAL]",dwVidMemTotal1, dwVidMemFree1);
	TextOut(m_DContext,10,130,lbuf,strlen(lbuf));

	ddsGAVMCaps.dwCaps = DDSCAPS_VIDEOMEMORY | DDSCAPS_NONLOCALVIDMEM;
	hr = pDD->GetAvailableVidMem(&ddsGAVMCaps, &dwVidMemTotal2, &dwVidMemFree2);
  sprintf(lbuf,"TOTAL:  %10u  FREE:  %10u - VIDEO[NONLOCAL]",dwVidMemTotal2, dwVidMemFree2);
	TextOut(m_DContext,10,150,lbuf,strlen(lbuf));

	ddsGAVMCaps.dwCaps = DDSCAPS_TEXTURE;
	hr = pDD->GetAvailableVidMem(&ddsGAVMCaps, &dwVidMemTotal3, &dwVidMemFree3);
  sprintf(lbuf,"TOTAL:  %10u  FREE:  %10u - TEXTURE",dwVidMemTotal3, dwVidMemFree3);
	TextOut(m_DContext,10,170,lbuf,strlen(lbuf));

	Sleep(1);

	}

  ReleaseDC(GetDesktopWindow(),m_DContext);
	return (1);
}